! ڵ㶨ģ
MODULE LINKMODULE
  IMPLICIT NONE
! ڵ㶨
  TYPE Linklist
    CHARACTER(10) :: Name
    INTEGER :: Number
    TYPE(Linklist), POINTER :: Prev
    TYPE(Linklist), POINTER :: Next
  END TYPE

CONTAINS
! ģڲ
! ӽڵ
  SUBROUTINE AddNode(Node, P, Type)
    IMPLICIT NONE

    TYPE(Linklist), POINTER :: Node, P
    INTEGER :: Type

    IF(1 == Type) THEN
      !ڵPڵNode
      P%Next => Node%Next
      P%Prev => Node
      IF(ASSOCIATED(Node%Next)) THEN
        Node%Next%Prev => P
      ENDIF
      Node%Next => P
    ELSE
      !ڵPڵNodeǰ
      P%Next => Node
      P%Prev => Node%Prev
      IF(ASSOCIATED(Node%Prev)) THEN
        Node %Prev%Next => P
      ENDIF
      Node%Prev => P
    ENDIF

  END SUBROUTINE AddNode
! Ƴڵ
  SUBROUTINE MoveNode(P)
    IMPLICIT NONE

    TYPE(Linklist), POINTER :: P
    TYPE(Linklist), POINTER :: Prev, Next

    Prev => P%Prev
    Next => P%Next
    DEALLOCATE(P)
    IF(ASSOCIATED(Prev)) THEN
      Prev%Next => Next
    ENDIF
    IF(ASSOCIATED(Next)) THEN
      Next%Prev => Prev
    ENDIF

  END SUBROUTINE MoveNode
! ڵ
  SUBROUTINE OutputNode(Head)
    IMPLICIT NONE

    TYPE(Linklist), POINTER :: Head, P

    P => Head
    DO WHILE(ASSOCIATED(P))
      PRINT *, P%Name, P%Number
      P => P%Next
    ENDDO

  END SUBROUTINE OutputNode

END MODULE LINKMODULE

! 
PROGRAM TEST1318
  USE LINKMODULE
  IMPLICIT NONE
! 
  TYPE(Linklist), POINTER :: Head
  TYPE(Linklist), POINTER :: Node, P
  INTEGER :: N, I, J, Err
! Ļʾ
  PRINT *, 'ĳ:'
  READ(*, *) N
  PRINT *, 'ʼ:'
  ALLOCATE(Head, STAT=Err)
  IF(0 /= Err) THEN
    PRINT *, 'ڴʧ!'
  ELSE
    Head%Name = '1ڵ'
    Head%Number = 1
    Head%Prev => NULL()
    Head%Next => NULL()
    P => Head
    DO J = 2, N
      ALLOCATE(P%Next, STAT=Err)
      IF(0 /= Err) THEN
        PRINT *, 'ڴʧ!'
        P%Next => NULL()
        EXIT
      ENDIF
      P%Next%Prev => P
      P => P%Next
      WRITE(P%Name, '("", I1, "ڵ")') J
      P%Number = J
    ENDDO
    P%Next => NULL()
  ENDIF
  PRINT *, '!'
! ڵ
  PRINT *, 'ҪݵĽڵżʽ[1-ڵ֮]'
  READ(*, *)N, J
  ALLOCATE(P, STAT=Err)
  IF(0 /= Err) THEN
    PRINT *, '½ڵ洢ռʧ!'
    STOP
  ENDIF
  P = Linklist('²ڵ', 1000, NULL(), NULL())
  Node => Head
  DO I = 2, N
    Node => Node%Next
  ENDDO
  CALL AddNode(Node, P, J)
  CALL OutputNode(Head)
! ɾڵ
  PRINT *, 'ҪɾĽڵ'
  READ(*, *)N
  P => Head
  DO I = 2, N
    P => P%Next
  ENDDO
  CALL MoveNode(P)
  CALL OutputNode(Head)

END PROGRAM TEST1318
