! ѧɼģ
MODULE ScoreList
  IMPLICIT NONE
! ѧͶ
  TYPE Student
    CHARACTER(10) :: Name
    INTEGER :: Number
    REAL :: CHN, MAT, ENG, CHE, PHY
  END TYPE Student
! ڵ㶨
  TYPE LinkList
    TYPE(Student) :: Node
    TYPE(LinkList), POINTER :: Next
  END TYPE LinkList

END MODULE ScoreList

! ӳ
SUBROUTINE PrintNode(Head)
  USE ScoreList
  IMPLICIT NONE
! 
  TYPE(LinkList), POINTER :: Head
  TYPE(LinkList), POINTER :: P
! õ
  P => Head
  IF(.NOT. ASSOCIATED(P)) THEN
    PRINT *, '޽ڵ!'
    RETURN
  ENDIF
! ѭ
  DO WHILE(ASSOCIATED(P))
    WRITE(*, '(1X, ":", A10, "ѧ:", I3.3)') P%Node%Name, P%Node%Number
    WRITE(*, '(1X, ":", F5.1, 1X, ":", F5.1, 1X, ":", F5.1, 1X, ":", F5.1, 1X, ":", F5.1)') &
        & P%Node%CHN, P%Node%MAT, P%Node%ENG, P%Node%CHE, P%Node%PHY
    P => P%Next
  END DO

 END SUBROUTINE PrintNode

! ҽڵӳ
SUBROUTINE FindNode(Head)
  USE ScoreList
  IMPLICIT NONE
! ڵ㶨
  TYPE(LinkList), POINTER :: Head
  TYPE(LinkList), POINTER :: P
  INTEGER :: Mark
! Ļʾ
  WRITE(*, '(1X, A, \)') 'ҵѧѧ:'
  READ(*, *) Mark
  P => Head
! ҽڵ
  DO WHILE(ASSOCIATED(P))
    IF(Mark == P%Node%Number) THEN
      PRINT *, 'ҵļ¼:'
      WRITE(*, '(1X, ":", A10, "ѧ:", I3.3)') P%Node%Name, P%Node%Number
      WRITE(*, '(1X, ":", F5.1, 1X, ":", F5.1, 1X, ":", F5.1, 1X, ":", F5.1, 1X, ":", F5.1)') &
        & P%Node%CHN, P%Node%MAT, P%Node%ENG, P%Node%CHE, P%Node%PHY
      RETURN
    ENDIF
    P => P%Next
  ENDDO
  PRINT *, 'ûзļ¼!'

END SUBROUTINE FindNode

! ݸӳ
SUBROUTINE UpdateNode(Head)
  USE ScoreList
  IMPLICIT NONE
! 
  TYPE(LinkList), POINTER :: Head
  TYPE(LinkList), POINTER :: P
  INTEGER :: Mark
  CHARACTER(3) :: Item
  REAL :: Score
! Ļʾ
  PRINT *, '* еĿĿʹĸ[CHN- MAT- ENG- CHE- PHY-]'
  PRINT *, '* ɼͨEND'
  WRITE(*, '(/, 1X, A, \)') '¼¼ѧѧ:'
  READ(*, *) Mark
  P => Head
! ѭ
  DO WHILE(ASSOCIATED(P))
    IF(Mark == P%Node%Number) THEN
      PRINT *, 'ҵļ¼:'
      PRINT *, 'Ҫ޸ĵĳɼ¼[Ŀ ɼ]:'
      DO
        READ(*, '(A3, 1X:F5.1)') Item, Score
        IF('END' == Item) EXIT
        SELECT CASE(Item)
          CASE ('CHN')
            P%Node%CHN = Score
          CASE ('MAT')
            P%Node%MAT = Score
          CASE ('ENG')
            P%Node%ENG = Score
          CASE ('CHE')
            P%Node%CHE = Score
          CASE ('PHY')
            P%Node%PHY = Score
        END SELECT
      ENDDO
      RETURN
    ENDIF
    P => P%Next
  ENDDO
  PRINT *, 'ûзļ¼!'

END SUBROUTINE UpdateNode

! ༶Աɼϵͳ
PROGRAM TEST1320
  USE ScoreList
  IMPLICIT NONE
! ӿ˵
  INTERFACE
    SUBROUTINE PrintNode(Head)
      USE ScoreList
      IMPLICIT NONE
      TYPE(LinkList), POINTER :: Head
    END SUBROUTINE PrintNode
    SUBROUTINE FindNode(Head)
      USE ScoreList
      IMPLICIT NONE
      TYPE(LinkList), POINTER :: Head
    END SUBROUTINE FindNode
    SUBROUTINE UpdateNode(Head)
      USE ScoreList
      IMPLICIT NONE
      TYPE(LinkList), POINTER :: Head
    END SUBROUTINE UpdateNode
  END INTERFACE
! 
  TYPE(LinkList), POINTER :: Head
  TYPE(LinkList), POINTER :: P, Pt
  TYPE(Student) :: Node
  INTEGER :: Count, I, Err, Fun
  CHARACTER(256) :: sFileName
  CHARACTER :: Save
  LOGICAL :: Exit
! ִж
  Exit = .FALSE.
  DO WHILE(.NOT. Exit)
    WRITE(*, '(1X, A, \)') 'ļ[END]:'
    READ(*, *) sFileName
    IF('END' == sFileName(1:3)) STOP
    INQUIRE(FILE=sFileName, EXIST=Exit)
    IF(.NOT. Exit) PRINT *, 'ļ!'
  ENDDO
! 
  ALLOCATE(Head, STAT=Err)
  IF(0 /= Err) THEN
    PRINT *, 'ڴʧ! ޷!'
    STOP
  ENDIF
  Head%Next => NULL()
  P => Head
  Count = 0
  OPEN(10, FILE=sFileName, STATUS='OLD')
  DO
    READ(10, *, END=10) Node%Name
    READ(10, *) Node%Number
    READ(10, *) Node%CHN, Node%MAT, Node%ENG, Node%CHE, Node%PHY 
    P%Node%Name = Node%Name
    P%Node%Number = Node%Number
    P%Node%CHN = Node%CHN
    P%Node%MAT = Node%MAT
    P%Node%ENG = Node%ENG
    P%Node%CHE = Node%CHE
    P%Node%PHY = Node%PHY
    Count = Count + 1
    PRINT *, '', Count, 'ݡ'
    !һڵĴ洢ռ
    ALLOCATE(P%Next, STAT=Err)
    IF(0 /= Err) THEN
      PRINT *, 'ڴʧ!'
      P%Next => NULL()
      EXIT
    ENDIF
    P => P%Next
  ENDDO
10 &
  DEALLOCATE(P)
  P => Head
  DO I = 1, Count-1
    P => P%Next
  ENDDO
  P%Next => NULL()
  CLOSE(10)
  PRINT *, 'ܼƶȡ', Count, '!'
! ݽв
  PRINT *, ''
  Fun = 100
  DO WHILE(0 /= Fun)
    WRITE(*, '(1X, A, \)') 'ѡ[1- 2- 3- 0-˳]:'
    READ(*, *) Fun
    SELECT CASE (Fun)
      CASE (1)
        CALL FindNode(Head)
      CASE (2)
        CALL UpdateNode(Head)
      CASE (3)
        CALL PrintNode(Head)
      CASE (0)
        EXIT
    END SELECT
  ENDDO
! ɺĴ
  WRITE(*, '(1X, A, \)') 'Ƿ񱣴ݣ[Y/N] '
  READ(*, *) Save
  IF('N' /= Save) THEN
    P => Head
    OPEN(10, FILE=sFileName)
    DO WHILE(ASSOCIATED(P))
      WRITE(10, '(1X, 3A)') "'", P%Node%Name, "'"
      WRITE(10, '(1X, I3)') P%Node%Number
      WRITE(10, '(1X, F5.1, 1X)') &
        P%Node%CHN, P%Node%MAT, P%Node%ENG, P%Node%CHE, P%Node%PHY
      P => P%Next
    ENDDO
    CLOSE(10)
  ENDIF
  P => Head
  Pt => Head
  DO WHILE(ASSOCIATED(P))
    P => Pt%Next
    DEALLOCATE(Pt)
    Pt => P
  ENDDO

END PROGRAM TEST1320
