! ղֵӳ
REAL FUNCTION Lagrange(X, XA, YA, N)
  IMPLICIT NONE
! 
  INTEGER, INTENT(IN) :: N
  REAL, INTENT(IN) :: X, XA(N), YA(N)
  REAL :: C1
  INTEGER :: I, J
! ݲֵ
  Lagrange = 0.0
  DO I = 1, N
    C1 = 1.0
    DO J = 1, N
      IF(J /= I) THEN
        C1 = C1*(X - XA(J))/(XA(I) - XA(J))
      ENDIF
    ENDDO
    Lagrange = Lagrange + C1*YA(I)
  ENDDO
  RETURN

END FUNCTION Lagrange

! ֵ
PROGRAM TEST1407
  IMPLICIT NONE
! 
  REAL, PARAMETER :: PI = 3.1415926
  REAL :: XA(10), YA(10) 
  INTEGER :: Nip
  REAL, ALLOCATABLE :: X(:), Y(:)
  REAL :: Inc, Xc
  INTEGER :: I, Err
  REAL, EXTERNAL :: Lagrange
! Ļʾͳʼ
  PRINT *, '10Sinֵ'
  DO I = 1, 10
    XA(I) = 360.0/9*(I - 1)
    YA(I) = SIN(PI*XA(I)/180.0)
  ENDDO
! ֵ
  PRINT *, 'ҪֵĿ'
  READ(*, *) Nip
  ALLOCATE(X(Nip), Y(Nip), STAT=Err)
  IF(0 == Err) THEN
    Xc = 0.0
    Inc = 360.0/(Nip - 1)
    DO I = 1, Nip
      X(I) = Xc
      Y(I) = Lagrange(X(I), XA, YA, 10)
      Xc = Xc + Inc
    ENDDO
  ELSE
    PRINT *, '̬ڴʧ!'
    STOP
  ENDIF
! ݱ
  OPEN(10, FILE='Lagrange.dat')
  WRITE(10, *) "TITLE = Lagrange Interpolation Result"
  WRITE(10, *) "VARIABLES = 'x' 'y'"
  WRITE(10, *) "ZONE T = 'Origin'"
  DO I = 1, 10
    WRITE(10, *) XA(I), YA(I)
  ENDDO
  WRITE(10, *) "ZONE T = 'Lagrange'"
  DO I = 1, Nip
    WRITE(10, *) X(I), Y(I)
  ENDDO
  CLOSE(10)

  DEALLOCATE(X, Y, STAT=Err)
  IF(0 /= Err) PRINT *, 'ע! ͷŶ̬ڴʧ!'

END PROGRAM TEST1407
