SUBROUTINE Random_File(Filename, Number)
  IMPLICIT NONE
! 
  CHARACTER(256) :: Filename
  INTEGER :: Number
  INTEGER :: I
  REAL :: Random
! ļ
  OPEN(10, FILE=Filename, FORM='UNFORMATTED')
    DO I = 1, Number
      CALL RANDOM_NUMBER(Random)
      Number = INT(100*Random)
      WRITE(10) Number
    ENDDO
  CLOSE(10)

END SUBROUTINE Random_File

SUBROUTINE Pick_Prime(Filename)
  IMPLICIT NONE
! 
  CHARACTER(256) :: Filename
  INTEGER :: Number
  INTEGER :: I
  REAL :: Random
  LOGICAL, EXTERNAL :: IsPrimeNumber
! ļ
  OPEN(20, STATUS='SCRATCH', FORM='UNFORMATTED')
  OPEN(10, FILE=Filename, FORM='UNFORMATTED')
    Number = 0
    DO
      READ(10, END=10)
      Number = Number + 1
    ENDDO
10 &
    REWIND(10)
    DO I = 1, Number
      READ(10) Number
      IF(IsPrimeNumber(Number)) THEN
        WRITE(20) Number
      ENDIF
    ENDDO
    REWIND(10)
    REWIND(20)
    DO
      READ(20, END=20) Number
      WRITE(10) Number
    ENDDO
20 &
  CLOSE(10)

END SUBROUTINE Pick_Prime

LOGICAL FUNCTION IsPrimeNumber(Number)
  IMPLICIT NONE
! 
  INTEGER :: Number
  INTEGER :: I
! ж
  DO I = 2, Number - 1
    IF(0 == MOD(Number, I)) THEN
      IsPrimeNumber = .FALSE.
      RETURN
    ENDIF
  ENDDO
  IsPrimeNumber = .TRUE.
  RETURN

END FUNCTION IsPrimeNumber

! ʱļ
PROGRAM TEST1501
  IMPLICIT NONE
! 
  CHARACTER(256) :: Filename
  INTEGER :: Number
  INTEGER :: I
! ĻϢ
  PRINT *, 'Input the data file name:'
  READ(*, *) Filename
  PRINT *, 'Input the numbers of random number:'
  READ(*, *) Number
! ӳ
  PRINT *, 'Generate the random number!'
  CALL Random_File(Filename, Number)
! ѡ
  PRINT *, 'Pick the prime number from the file!'
  CALL Pick_Prime(Filename)
! ʾļ
  PRINT *, 'All prime numbers are listed in the following:'
  OPEN(10, FILE=Filename, FORM='UNFORMATTED')
    DO
      READ(10, END=10) Number
      WRITE(*, *)Number
      I = I + 1
    ENDDO
10 &
  WRITE(*, '(1X, "There are totally", I3, " prime numbers in the file.")') I

END PROGRAM TEST1501
