! ģ鶨
MODULE Search_Module
  IMPLICIT NONE
! ӿ˵
  INTERFACE Binary_Search
    MODULE PROCEDURE Binary_Search_i
    MODULE PROCEDURE Binary_Search_r
    MODULE PROCEDURE Binary_Search_d
  END INTERFACE Binary_search

CONTAINS
! Ķ
  LOGICAL FUNCTION Binary_Search_i(S, G)
    IMPLICIT NONE
! 
    INTEGER :: S(:), G
    INTEGER :: N, L, R, M
! Ϣ
    N = SIZE(S)
    L = 1
    R = N
    M = (L + R)/2
    IF((G<S(1)) .OR. (G>S(N))) THEN
      Binary_Search_i = .FALSE.
      RETURN
    ENDIF
! 
    DO WHILE(L < R)
      IF(G > S(M)) THEN
        L = M + 1
        M = (L + R)/2
      ELSEIF(G < S(M)) THEN
        R = M - 1
        M = (L + R)/2
      ELSE
        Binary_Search_i = .TRUE.
        RETURN
      ENDIF
    ENDDO
    Binary_Search_i = .FALSE.
    RETURN

  END FUNCTION Binary_Search_i

! ʵĶ
  LOGICAL FUNCTION Binary_Search_r(S, G)
    IMPLICIT NONE
! 
    REAL :: S(:), G
    INTEGER :: N, L, R, M
! ݵϢ
    N = SIZE(S)
    L = 1
    R = N
    M = (L + R)/2
    IF((G<S(1)) .OR. (G>S(N))) THEN
      Binary_Search_r = .FALSE.
      RETURN
    ENDIF
! 
    DO WHILE(L < R)
      IF(G > S(M)) THEN
        L = M + 1
        M = (L + R)/2
      ELSEIF(G < S(M)) THEN
        R = M - 1
        M = (L + R)/2
      ELSE
        Binary_Search_r = .TRUE.
        RETURN
      ENDIF
    ENDDO
    Binary_Search_r = .FALSE.
    RETURN

  END FUNCTION Binary_Search_r

! ˫Ķ
  LOGICAL FUNCTION Binary_Search_d(S, G)
    IMPLICIT NONE
! 
    REAL(8) :: S(:), G
    INTEGER :: N, L, R, M
! ݵϢ
    N = SIZE(S)
    L = 1
    R = N
    M = (L + R)/2
    IF((G<S(1)) .OR. (G>S(N))) THEN
      Binary_Search_d = .FALSE.
      RETURN
    ENDIF
! 
    DO WHILE(L < R)
      IF(G > S(M)) THEN
        L = M + 1
        M = (L + R)/2
      ELSEIF(G < S(M)) THEN
        R = M - 1
        M = (L + R)/2
      ELSE
        Binary_Search_d = .TRUE.
        RETURN
      ENDIF
    ENDDO
    Binary_Search_d = .FALSE.
    RETURN

  END FUNCTION Binary_Search_d

END MODULE Search_Module

! ַ
PROGRAM TEST1602
  USE SEARCH_MODULE
  IMPLICIT NONE
! 
  INTEGER :: I4(10) = (/1, 3, 5, 6, 9, 10, 13, 20, 25, 34/)
  INTEGER :: Ig
! ʾ
  PRINT *, 'Ҫҵ'
  READ(*, *)Ig
  PRINT *, 'ԭʼ:', I4
  IF(Binary_Search(I4, Ig)) THEN
    PRINT *, 'д:', Ig
  ELSE
    PRINT *, 'ûҪҵ!'
  ENDIF

END PROGRAM TEST1602
