! ӳķ - 
COMPLEX FUNCTION F0(A, B, Z)
  IMPLICIT NONE

  COMPLEX :: A, B, Z

  F0 = A*Z + B*CONJG(z)
  RETURN

END FUNCTION F0

COMPLEX FUNCTION F1(C, D, Z)
  IMPLICIT NONE

  COMPLEX :: C, D, Z

  F1 = C*(Z - 1) + D*(CONJG(Z) - 1) + 1
  RETURN

END FUNCTION F1

! 
PROGRAM TEST1004
  IMPLICIT NONE
! 
  COMPLEX :: F0, F1
  COMPLEX :: A, B, C, D, Origin, VAL
  INTEGER :: Order, Loop, I, FUNC_LIST, LSB
  PARAMETER (Origin=(0.0,0.0), Order=18)
! ִж
  A = Origin
  B = CMPLX(1./2, SQRT(3.)/6)
  C = Origin
  D = CMPLX(1./2,-SQRT(3.)/6)
! ִзκдļ
  OPEN(10, FILE = 'FENXING.PLT')
  DO LOOP = 0, 2**Order - 1
    VAL = F0(A, B, VAL)
    FUNC_LIST = LOOP
    DO I = 1, Order
      LSB = FUNC_LIST .AND. '01'X
      IF(0 == LSB) THEN
        VAL = F0(A, B, VAL)
      ELSE
        VAL = F1(C, D, VAL)
      ENDIF
      FUNC_LIST = FUNC_LIST/2
    END DO
    WRITE(10, *) REAL(VAL), AIMAG(VAL)
  END DO
  CLOSE(10)

END PROGRAM TEST1004
