! ָķ
MODULE DATA_DEFINE
  IMPLICIT NONE
! 
  TYPE BREAD
    CHARACTER(10) :: Zone
    CHARACTER(10) :: Logo
    INTEGER :: Weight
    REAL :: Price
  END TYPE

  TYPE PBREAD
    TYPE(BREAD), POINTER :: P
  END TYPE

CONTAINS
!ģڲ
  SUBROUTINE SORTNAME(P)
    IMPLICIT NONE

    TYPE(PBREAD) :: P(:)
    TYPE(PBREAD) :: Ptemp
    INTEGER :: N, I, J

    N = SIZE(P)
    DO I = 1, N-1
      DO J = I+1, N
        IF(P(I)%P%Zone > P(J)%P%Zone) THEN
          Ptemp = P(I)
          P(I) = P(J)
          P(J) = Ptemp
        ENDIF
      ENDDO
    ENDDO

  END SUBROUTINE SORTNAME

  SUBROUTINE SORTPRICE(P)
    IMPLICIT NONE

    TYPE(PBREAD) :: P(:)
    TYPE(PBREAD) :: Ptemp
    INTEGER :: N, I, J

    N = SIZE(P)
    DO I = 1, N-1
      DO J = I+1, N
        IF((P(I)%P%Price/P(I)%P%Weight) > (P(J)%P%Price/P(J)%P%Weight)) THEN
          Ptemp = P(I)
          P(I) = P(J)
          P(J) = Ptemp
        ENDIF
      ENDDO
    ENDDO

  END SUBROUTINE SORTPRICE

END MODULE DATA_DEFINE

! 
PROGRAM TEST1312
  USE DATA_DEFINE
  IMPLICIT NONE
! 弰ֵ
  TYPE(BREAD), TARGET :: Good(5) = (/BREAD ('', '', 500, 5.00), &
                                    BREAD('', '', 500, 4.90), &
                                    BREAD('Ϻ', 'ȫ', 250, 2.47), &
                                    BREAD('人', '', 250, 2.39), &
                                    BREAD('ɶ', '츮', 500, 4.70)/)
  TYPE(PBREAD) :: P(5)
  INTEGER :: I
! ָϼ
  FORALL(I=1:5)
  P(I)%P => Good(I)
  END FORALL
  PRINT *, 'ѡʽ[1- 2-۸ 0-˳]:' 
  READ(*, *) I
  DO WHILE (0 /= I)
    IF(1 == I) THEN
      PRINT *, '  Ʒ  (g)  ۸(Y)'
      CALL SORTNAME(P)
      WRITE(*, '(5(1X, 2(A4, 2X), I3, 6X, F4.2/))')(P(I)%P, I =1, 5)
    ELSEIF(2 == I) THEN
      PRINT *, '  Ʒ  (g)  ۸(Y)'
      CALL SORTPRICE(P)
      WRITE(*, '(5(1X, 2(A4, 2X), I3, 6X, F4.2/))')(P(I)%P, I =1, 5)
    ENDIF
    PRINT *, 'ѡʽ[1-ص 2-۸ 0-˳]:'
    READ(*, *) I
  END DO
  PRINT *, '  Ʒ  (g)  ۸(Y)[ԭʼ]'
  WRITE(*, '(5(1X, 2(A4, 2X), I3, 6X, F4.2/))')(Good(I), I =1, 5)

END PROGRAM TEST1312
