! Խǻӳ
SUBROUTINE Diagonal(Matrix, B, Type)
  IMPLICIT NONE
! 
  REAL :: Matrix(:, :)
  REAL :: B(:)
  INTEGER :: Type
  INTEGER :: M, N
  INTEGER :: I, J
  REAL :: F
! Ϣ
  M = SIZE(Matrix, 1)
  N = SIZE(Matrix, 2)
  IF(M /= N) THEN
    PRINT *, 'ľ!'
    STOP
  ENDIF
! ǻ
  SELECT CASE(Type)
    CASE (1)
    !
      DO J = 1, N-1
        DO I = J+1, M
          F = Matrix(I, J)/Matrix(J, J)
          Matrix(I, J:N) = Matrix(I, J:N) - Matrix(J, J:N)*F
          B(I) = B(I) - B(J)*F
        ENDDO
      ENDDO
    CASE (-1)
    !
      DO J = N, 2, -1
        DO I = J-1, 1, -1
          F = Matrix(I, J)/Matrix(J, J)
          Matrix(I, J:N) = Matrix(I, J:N) - Matrix(J, J:N)*F
          B(I) = B(I) - B(J)*F
        ENDDO
      ENDDO
  END SELECT

END SUBROUTINE Diagonal

! Gauss Jordanȥ
PROGRAM TEST1403
  IMPLICIT NONE
! ӿ˵
  INTERFACE
    SUBROUTINE Gauss_Jordan(A, B, X)
      IMPLICIT NONE
      REAL :: A(:, :)
      REAL :: B(:), X(:)
    END SUBROUTINE Gauss_Jordan
  END INTERFACE
! 
  INTEGER, PARAMETER :: N = 4
  REAL :: A(N, N)
  REAL :: B(N)
  REAL :: X(N)
  INTEGER :: I, J
! Ļ
  PRINT *, '뷽̵ϵ[4X4]:'
  DO I = 1, N
    READ(*, *)(A(I, J), J=1, N)
  ENDDO
  PRINT *, '뷽̵Ľ[4X1]:'
  READ(*, *)(B(I), I=1, N)
! Gauss Jordanȥ
  CALL Gauss_Jordan(A, B, X)
  WRITE(*, '(1X,A)')'Ľ:'
  WRITE(*, '(1X,"X(",I2,") = ", F10.6)')(I, X(I), I=1,N)
  
END PROGRAM TEST1403
