! ˳ģ鶨
MODULE SEARCH_MODULE
  IMPLICIT NONE
! ӿ˵
  INTERFACE Sequence_Search
    MODULE PROCEDURE Sequence_Search_r
    MODULE PROCEDURE Sequence_Search_d
    MODULE PROCEDURE Sequence_Search_i
  END INTERFACE

CONTAINS
! ʵ˳
  LOGICAL FUNCTION Sequence_Search_r(A, G)
    IMPLICIT NONE
! 
    REAL :: A(:), G
    INTEGER :: N, I
! 
    N = SIZE(A)
    DO I = 1, N
      IF(G == A(I)) THEN
        Sequence_Search_r = .TRUE.
        RETURN
      ENDIF
    ENDDO
    Sequence_Search_r = .FALSE.
    RETURN

  END FUNCTION Sequence_Search_r

! ˫˳
  LOGICAL FUNCTION Sequence_Search_d(A, G)
    IMPLICIT NONE
! 
    REAL(8) :: A(:), G
    INTEGER :: N, I
! 
    N = SIZE(A)
    DO I = 1, N
      IF(G == A(I)) THEN
        Sequence_Search_d = .TRUE.
        RETURN
      ENDIF
    ENDDO
    Sequence_Search_d = .FALSE.
    RETURN

  END FUNCTION Sequence_Search_d

! ˳
  LOGICAL FUNCTION Sequence_Search_i(A, G)
    IMPLICIT NONE
! 
    INTEGER :: A(:), G
    INTEGER :: N, I
! 
    N = SIZE(A)
    DO I = 1, N
      IF(G == A(I)) THEN
        Sequence_Search_i = .TRUE.
        RETURN
      ENDIF
    ENDDO
    Sequence_Search_i = .FALSE.
    RETURN

  END FUNCTION Sequence_Search_i

END MODULE SEARCH_MODULE

! ˳
PROGRAM TEST1601
  USE SEARCH_MODULE
  IMPLICIT NONE
! 
  INTEGER, ALLOCATABLE :: I4(:)
  REAL, ALLOCATABLE :: R4(:)
  REAL(8), ALLOCATABLE :: R8(:)
  REAL :: Temp
  INTEGER :: Ig
  REAL :: Rg
  REAL(8) :: Dg
  INTEGER :: N, Type, Err, I
! ʼ
  PRINT *, ':'
  READ(*, *) N
  PRINT *, 'ѡ[1- 2-ʵ 3-˫]'
  READ(*, *) Type
  PRINT *, 'Ҫҵ'
  CALL RANDOM_SEED()
! ͬ
  SELECT CASE (Type)
    CASE(1)
      ALLOCATE(I4(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      DO I = 1, N
        CALL RANDOM_NUMBER(Temp)
        I4(I) = ANINT(Temp*6.0)
      ENDDO
      READ(*, *) Ig
      PRINT *, 'ԭʼ:', I4
      IF(Sequence_Search(I4, Ig)) THEN
        PRINT *, 'д:', Ig
      ELSE
        PRINT *, 'ûҪҵ!'
      ENDIF
    CASE(2)
      ALLOCATE(R4(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      CALL RANDOM_NUMBER(R4)
      READ(*, *)Rg
      PRINT *, 'ԭʼ:', R4
      IF(Sequence_Search(R4, Rg)) THEN
        PRINT *, 'д:', Rg
      ELSE
        PRINT *, 'ûҪҵ!'
      ENDIF
    CASE(3)
      ALLOCATE(R8(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      CALL RANDOM_NUMBER(R8)
      READ(*, *)Dg
      PRINT *, 'ԭʼ:', R8
      IF(Sequence_Search(R8, Dg)) THEN
        PRINT *, 'д:', Dg
      ELSE
        PRINT *, 'ûҪҵ!'
      ENDIF
  END SELECT

END PROGRAM TEST1601
