! ðģ
MODULE SORT_MODULE
  IMPLICIT NONE
! ӿ˵
  INTERFACE Bubble_Sort
    MODULE PROCEDURE Bubble_Sort_r
    MODULE PROCEDURE Bubble_Sort_i
    MODULE PROCEDURE Bubble_Sort_d
  END INTERFACE

CONTAINS
! ʵð
  SUBROUTINE Bubble_Sort_r(A)
    IMPLICIT NONE
! 
    REAL :: A(:)
    INTEGER :: N, I, J
    REAL :: Temp
! 
    N = SIZE(A)
    DO J = N-1, 1, -1
      DO I = 1, J
        IF(A(I) > A(I+1)) THEN
          Temp = A(I)
          A(I) = A(I + 1)
          A(I + 1) = Temp
        ENDIF
      ENDDO
    ENDDO

  END SUBROUTINE

! ð
  SUBROUTINE Bubble_Sort_i(A) 
    IMPLICIT NONE
! 
    INTEGER :: A(:)
    INTEGER :: N, I, J
    INTEGER :: Temp
! 
    N = SIZE(A)
    DO J = N-1, 1, -1
      DO I = 1, J
        IF(A(I) > A(I+1)) THEN
          Temp = A(I)
          A(I) = A(I + 1)
          A(I + 1) = Temp
        ENDIF
      ENDDO
    ENDDO

  END SUBROUTINE

! ˫
  SUBROUTINE Bubble_Sort_d(A) 
    IMPLICIT NONE
! 
    REAL(8) :: A(:)
    INTEGER :: N, I, J
    REAL(8) :: Temp
! 
    N = SIZE(A)
    DO J = N-1, 1, -1
      DO I = 1, J
        IF(A(I) > A(I+1)) THEN
          Temp = A(I)
          A(I) = A(I + 1)
          A(I + 1) = Temp
        ENDIF
      ENDDO
    ENDDO

  END SUBROUTINE

END MODULE SORT_MODULE

! ð
PROGRAM TEST1605
  USE SORT_MODULE
  IMPLICIT NONE
! 
  INTEGER, ALLOCATABLE :: I4(:)
  REAL, ALLOCATABLE :: R4(:), Temp
  REAL(8), ALLOCATABLE :: R8(:)
  INTEGER :: N, Type, Err, I
! ʾϢ
  PRINT *, ':'
  READ(*, *) N
  PRINT *, 'ѡ[1- 2-ʵ 3-˫]'
  READ(**) Type
  CALL RANDOM_SEED()
! ʼ
  SELECT CASE (Type)
    CASE(1)
      ALLOCATE(I4(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      DO I = 1, N
        CALL RANDOM_NUMBER(Temp)
        I4(I) = ANINT(Temp*5.0)
      ENDDO
      PRINT *, 'ԭʼ:', I4
      CALL Bubble_Sort(I4)
      PRINT *, ':', I4
    CASE(2)
      ALLOCATE(R4(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      CALL RANDOM_NUMBER(R4)
      PRINT *, 'ԭʼ:', R4
      CALL Bubble_Sort(R4)
      PRINT *, ':', R4
    CASE(3)
      ALLOCATE(R8(N), STAT=Err)
      IF(0 /= Err) THEN
       PRINT *, 'ڴʧ!'
       STOP
      ENDIF
      CALL RANDOM_NUMBER(R8)
      PRINT *, 'ԭʼ:', R8
      CALL Bubble_Sort(R8)
      PRINT *, ':', R8
  END SELECT

END PROGRAM TEST1605
